SuperStrict

SetGraphicsDriver GLMax2DDriver()

Graphics 800, 600

Local image1:TImage = LoadAnimImage("test9.png", 128, 128, 0, 32)
Local image4:TImage = LoadAnimImage("test3.png", 128, 128, 0, 32)
Local image2:TImage = LoadAnimImage("test17.png", 128, 128, 0, 32)
Local image3:TImage = LoadAnimImage("test18.png", 128, 128, 0, 32)

Local f:Float
Local f2:Float = 15

Repeat
	While Not KeyHit(KEY_SPACE)
		
		f:+0.5
		f2:+1
	
		Cls
		SetBlend ALPHABLEND
		'SetScale 1, 1
		TileImage(image1, 0, 0, f Mod 32)
		SetBlend ALPHABLEND
		SetScale 2, 2
		TileImage2(image1, 0, 0, f2 Mod 32)
		SetBlend ALPHABLEND
		SetScale 4, 4
		TileImage2(image1, 0, 0, f2 Mod 32)
		
		Flip
		
		If KeyDown(KEY_ESCAPE)
			End
		End If
	
	Wend
	
	While Not KeyHit(KEY_SPACE)
		
		f:+0.5
		f2:+1
	
		Cls
		SetBlend ALPHABLEND
		'SetScale 1, 1
		TileImage(image4, 0, 0, f Mod 32)
		SetBlend ALPHABLEND
		SetScale 2, 2
		TileImage2(image4, 0, 0, f2 Mod 32)
		SetBlend ALPHABLEND
		SetScale 4, 4
		TileImage2(image4, 0, 0, f2 Mod 32)
		
		Flip
		
		If KeyDown(KEY_ESCAPE)
			End
		End If
	
	Wend
	
	While Not KeyHit(KEY_SPACE)
		
		f:+0.5
		f2:+1
	
		Cls
		SetBlend ALPHABLEND
		SetScale 1, 1
		TileImage(image2, 0, 0, f Mod 32)
		SetBlend ALPHABLEND
		SetScale 2, 2
		TileImage2(image2, 0, 0, f2 Mod 32)
		SetBlend ALPHABLEND
		SetScale 4, 4
		TileImage2(image2, 0, 0, f2 Mod 32)
		
		Flip
		
		If KeyDown(KEY_ESCAPE)
			end
		End If
	
	Wend
	
	While Not KeyHit(KEY_SPACE)
		
		f:+0.5
		f2:+1
	
		Cls
		SetBlend ALPHABLEND
		SetScale 1, 1
		TileImage(image3, 0, 0, f Mod 32)
		SetBlend ALPHABLEND
		SetScale 2, 2
		TileImage2(image3, 0, 0, f2 Mod 32)
		SetBlend ALPHABLEND
		SetScale 4, 4
		TileImage2(image3, 0, 0, f2 Mod 32)
		
		Flip
		
		If KeyDown(KEY_ESCAPE)
			end
		End If
	
	Wend
Forever

Function TileImage2 (image:TImage, x:Float = 0:Float, y:Float = 0:Float, frame:Int = 0)

    Local scale_x#, scale_y#
    GetScale(scale_x#, scale_y#)

    Local viewport_x%, viewport_y%, viewport_w%, viewport_h%
    GetViewport(viewport_x, viewport_y, viewport_w, viewport_h)

    Local origin_x#, origin_y#
    GetOrigin(origin_x, origin_y)

    Local handle_X#, handle_y#
    GetHandle(handle_X#, handle_y#)

    Local image_h# = ImageHeight(image)
    Local image_w# = ImageWidth(image)

    Local w#=image_w * Abs(scale_x#)
    Local h#=image_h * Abs(scale_y#)

    Local ox#=viewport_x-w+1
    Local oy#=viewport_y-h+1

    origin_X = origin_X Mod w
    origin_Y = origin_Y Mod h

    Local px#=x+origin_x - handle_x
    Local py#=y+origin_y - handle_y

    Local fx#=px-Floor(px)
    Local fy#=py-Floor(py)
    Local tx#=Floor(px)-ox
    Local ty#=Floor(py)-oy

    If tx>=0 tx=tx Mod w + ox Else tx = w - -tx Mod w + ox
    If ty>=0 ty=ty Mod h + oy Else ty = h - -ty Mod h + oy

    Local vr#= viewport_x + viewport_w, vb# = viewport_y + viewport_h

    SetOrigin 0,0
    Local iy#=ty
    While iy<vb + h ' add image height to fill lower gap
        Local ix#=tx
        While ix<vr + w ' add image width to fill right gap
            DrawImage(image, ix+fx,iy+fy, frame)
            ix=ix+w
        Wend
        iy=iy+h
    Wend
    SetOrigin origin_x, origin_y

End Function